<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/SXR.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/SXR.py</title>
<link href="../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/SXR.py</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="py-comment"># Copyright (C) 2008 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno"> 7</span>
<a id="line8"></a><span class="lineno"> 8</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/SXR/Entry.html">Entry</a>(object):</span>
<a id="line9"></a><span class="lineno"> 9</span>
<a id="line10"></a><span class="lineno">10</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/SXR/Entry.html#__init__">__init__</a>(self):</span>
<a id="line11"></a><span class="lineno">11</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Represents a set of references found for a given symbol.&quot;&quot;&quot;</span></span>
<a id="line12"></a><span class="lineno">12</span>
<a id="line13"></a><span class="lineno">13</span><span class="line">        self.definitions = []</span>
<a id="line14"></a><span class="lineno">14</span><span class="line">        <span class="py-string">&quot;List of (file, line, scope) tuples.&quot;</span></span>
<a id="line15"></a><span class="lineno">15</span><span class="line">        self.calls = []</span>
<a id="line16"></a><span class="lineno">16</span><span class="line">        <span class="py-string">&quot;List of (file, line, scope) tuples.&quot;</span></span>
<a id="line17"></a><span class="lineno">17</span><span class="line">        self.references = []</span>
<a id="line18"></a><span class="lineno">18</span><span class="line">        <span class="py-string">&quot;List of (file, line, scope) tuples.&quot;</span></span>
<a id="line19"></a><span class="lineno">19</span>
<a id="line20"></a><span class="lineno">20</span>
<a id="line21"></a><span class="lineno">21</span><span class="line"><span class="py-keyword">class</span> <a href="../../Scopes/Synopsis/SXR/SXR.html">SXR</a>(dict):</span>
<a id="line22"></a><span class="lineno">22</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Symboltable containing source code locations of symbol definitions,</span></span>
<a id="line23"></a><span class="lineno">23</span><span class="line"><span class="py-string">    as well as different types of references.&quot;&quot;&quot;</span></span>
<a id="line24"></a><span class="lineno">24</span>
<a id="line25"></a><span class="lineno">25</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/SXR/SXR.html#__init__">__init__</a>(self):</span>
<a id="line26"></a><span class="lineno">26</span>
<a id="line27"></a><span class="lineno">27</span><span class="line">        self._index = {}</span>
<a id="line28"></a><span class="lineno">28</span>
<a id="line29"></a><span class="lineno">29</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/SXR/SXR.html#index">index</a>(self):</span>
<a id="line30"></a><span class="lineno">30</span>
<a id="line31"></a><span class="lineno">31</span><span class="line">        <span class="py-keyword">return</span> self._index</span>
<a id="line32"></a><span class="lineno">32</span>
<a id="line33"></a><span class="lineno">33</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/SXR/SXR.html#generate_index">generate_index</a>(self):</span>
<a id="line34"></a><span class="lineno">34</span><span class="line">        <span class="py-string">&quot;&quot;&quot;(Re-)generate an index after entries have been added.&quot;&quot;&quot;</span></span>
<a id="line35"></a><span class="lineno">35</span>
<a id="line36"></a><span class="lineno">36</span><span class="line">        <span class="py-comment"># Sort the data</span></span>
<a id="line37"></a><span class="lineno">37</span><span class="line">        <span class="py-keyword">for</span> target, entry <span class="py-keyword">in</span> self.items():</span>
<a id="line38"></a><span class="lineno">38</span><span class="line">            entry.calls.sort()</span>
<a id="line39"></a><span class="lineno">39</span><span class="line">            entry.references.sort()</span>
<a id="line40"></a><span class="lineno">40</span>
<a id="line41"></a><span class="lineno">41</span><span class="line">            name = target[-1]</span>
<a id="line42"></a><span class="lineno">42</span><span class="line">            self._index.setdefault(name,[]).append(target)</span>
<a id="line43"></a><span class="lineno">43</span><span class="line">            <span class="py-comment"># If it's a function name, also add without the parameters</span></span>
<a id="line44"></a><span class="lineno">44</span><span class="line">            paren = name.find(<span class="py-string">'('</span>)</span>
<a id="line45"></a><span class="lineno">45</span><span class="line">            <span class="py-keyword">if</span> paren != -1:</span>
<a id="line46"></a><span class="lineno">46</span><span class="line">                self._index.setdefault(name[:paren],[]).append(target)</span>
<a id="line47"></a><span class="lineno">47</span>
<a id="line48"></a><span class="lineno">48</span><span class="line">    <span class="py-keyword">def</span> <a href="../../Scopes/Synopsis/SXR/SXR.html#merge">merge</a>(self, other):</span>
<a id="line49"></a><span class="lineno">49</span>
<a id="line50"></a><span class="lineno">50</span><span class="line">        <span class="py-keyword">for</span> k <span class="py-keyword">in</span> other:</span>
<a id="line51"></a><span class="lineno">51</span><span class="line">            e = other[k]</span>
<a id="line52"></a><span class="lineno">52</span><span class="line">            entry = self.setdefault(k, Entry())</span>
<a id="line53"></a><span class="lineno">53</span><span class="line">            <span class="py-comment"># TODO: Should we try to eliminate duplicates here ?</span></span>
<a id="line54"></a><span class="lineno">54</span><span class="line">            entry.definitions += e.definitions</span>
<a id="line55"></a><span class="lineno">55</span><span class="line">            entry.calls += e.calls</span>
<a id="line56"></a><span class="lineno">56</span><span class="line">            entry.references += e.references</span>
<a id="line57"></a><span class="lineno">57</span>
<a id="line58"></a><span class="lineno">58</span><span class="line">        self.generate_index()</span>
<a id="line59"></a><span class="lineno">59</span>
<a id="line60"></a><span class="lineno">60</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:14 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
